%TITLE "Graphic screen demonstration."
; By Tim Van Dusen

;***********************************************************
; Recommended for EGA or VGA " O N L Y "
; NOTE: some of the  BIOS  calls  here  will not work on all
;  machines. Feel  free to  rearrange  this code however you 
;  wish, to make it work on your machine. 
; If you found this little demo useful, let me know... Okay?

storage segment stack 'stack'
db      80h dup(?)
storage ends

data segment
count           dw      (?)    
       
ghost           db      '        GHOST `'

x               db      '"3-D"`'
data ends

code segment   'code'
extrn putcursor:proc, bioswrite:proc

assume cs:code, ss:storage, ds:data
start:

; BIOS CALL TO SET SCREEN TO 640(wide)x350(tall) GRAPHIC MODE
mov ah,0                
mov al,10h
int 10h

; COUNT WE'LL BE USING SINCE SCREEN IS 350 PIXELS TALL
mov [count],350

; BIOS CALL TO WRITE "ONE" PIXEL TO SCREEN. One pixel is too 
;  hard to see, so we'll make a diagonal line from top to bottom
mov ah,0ch              
mov bh,0
mov dx,0000     ; row number. Start line at top of page (first line)
mov cx,0145     ; column number - screen is 640 pixels wide. That makes it
                ;  wider than it is tall. Therefore, to center the "X", use
                ;  the formula  (640 - 350) / 2 to off-center start of next
                ;  line. (I had to use my fingers "and" toes for that one).


mov al,04       ; "04" is color code for "red"
jmp over        ; don't want to use above values again    
again:
call pause      ; procedure below to cause brief pause between
                ;  writing of pixels (this may not work on older
                ; machines. If not, just delete it and re-assemble,
                ; or create your own slow-motion procedure
inc dx          ; add one pixel to right of first pixel
inc cx          ; and down one pixel
over:           ; jump from above (used only once to place first dot
int 10h         ; write the pixel
dec [count]     ; WHEW! one pixel done. (wonder how many are left?)
cmp [count],0   ; was that the last one of "350"
jne again       ; NOPE guess not. Do it one more time


; THAT WAS FUN, SO LET'S DO IT AGAIN    
mov [count],350
mov ah,0ch
mov bh,0
mov dx,0350     ; This time start from bottom **
mov cx,0486     ; Use formula (above) to start line that goes back up,
                ;  slightly off-center
mov al,04       ; Still red
jmp over2
again2:
call pause
dec dx          ; ** and work our way up
dec cx
over2:
int 10h
dec [count]
cmp [count],0
jne again2

; THE NEXT TWO ROUTINES ARE REPEATS OF ABOVE (with different figures)
mov [count],350
mov ah,0ch
mov bh,0
mov dx,0000       ; row number
mov cx,0486       ; column number
mov al,04
jmp over3
again3:
call pause
inc dx
dec cx
over3:
int 10h
dec [count]
cmp [count],0
jne again3

mov [count],350
mov ah,0ch
mov bh,0
mov dx,0350       ; row number
mov cx,0145       ; column number
mov al,04
jmp over4
again4:
call pause
dec dx
inc cx
over4:
int 10h
dec [count]
cmp [count],0
jne again4


; WRITE TO GRAPHIC SCREEN using routine (not included here) which calls 
;  BIOS int 10h functions 02h (to first place cursor) and then function 
;  03h (to write text at current cursor location). 
mov ax,data
mov ds,ax
mov es,ax
mov dh,12
mov dl,29
call putcursor
mov bl,01
mov di,offset ghost   
push bp
mov bp,offset ghost
call bioswrite
pop bp

; more text writing ........... :)
mov dh,15
mov dl,37
call putcursor
mov bl,94h
mov di,offset x
push bp
mov bp,offset x
call bioswrite
pop bp

mov [count],350
mov ah,0ch
mov bh,0
mov dx,0350       ; row number
mov cx,0145       ; column number
mov al,04
jmp over5
again5:
dec dx
inc cx
over5:
int 10h
dec [count]
cmp [count],0
jne again5

mov [count],350
mov ah,0ch
mov bh,0
mov dx,0350     ; This time start from bottom **
mov cx,0486     ; Use formula (above) to start line that goes back up,
                ;  slightly off-center
mov al,04       ; Still red
jmp over6
again6:
;call pause
dec dx          ; ** and work our way up
dec cx
over6:
int 10h
dec [count]
cmp [count],0
jne again6




; CALL BIOS TO GET KEYBOARD INPUT. Will just wait around untill a key
;  is pressed. Then it will store the key in a register (just in case
;  you want to take a look at it) and then proceed with next line.
mov ah,0
int 16h

; RESETS VIDEO TO NORMAL TEXT MODE .... this is the mode most often 
;  while fiddlin' at the "C" prompt.
mov ah,00
mov al,02
int 10h

; TAAA-DUMMM.... end of session
mov ah,04ch
int 21h

proc pause
push ax
push cx
push dx
mov ah,86h
mov cx,0
mov dx,0fffh
int 15h
pop dx
pop cx
pop ax
ret
endp pause

code ends
end start
end

